<template>
	<div id="audit-logs" class="content">
		<div class="header">
			<h2>Audit Logs</h2>
		</div>
		<div class="container-fluid">
			<div class="row">
				<div class="col-12">
					<div class="wrapper">
						<tabs>
							<tab name="Logs" title="Logs">
								<!-- <div class="mt-2 mb-3">
                                    <div class="d-flex flex-md-row flex-column align-items-center justify-content-between">
                                        <div class="d-flex flex-column flex-md-row align-items-center mt-3 mt-md-0">
                                            <div class="d-flex">
                                                <button class="download btn btn-fluid text-uppercase btn-reset" type="submit" @click="downloadToCSV">
                                                    Download To CSV
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                </div> -->
								<vuetable
									ref="logsTable"
									:api-mode="false"
									:css="tableClass"
									:data="tableData"
									:data-manager="dataManager"
									:fields="tableFields"
								></vuetable>

								<div
									class="pagination ui basic segment grid d-flex flex-column flex-md-row justify-content-between"
								>
									<vuetable-pagination-info
										ref="paginationInfoLogs"
									></vuetable-pagination-info>

									<vuetable-pagination
										ref="paginationLogs"
										class="mt-4 mt-md-0"
										@vuetable-pagination:change-page="
											changePage($event, 'Logs')
										"
									></vuetable-pagination>
								</div>
							</tab>
						</tabs>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import Tabs from "../../components/tab/Tabs";
import Tab from "../../components/tab/Tab";
import PerPage from "../../components/table/PerPage";
import UserTrailService from "@/services/UserTrailService";

// Import DayJS. Alternative to moment js. Better performance compare to moment.
import dayjs from "dayjs";

export default {
	components: {
		Tabs,
		Tab,
		PerPage,
	},
	data() {
		return {
			activeTab: "Logs",
			tableClass: {
				tableClass: "ui striped table",
				ascendingIcon: "icon-down-open",
				descendingIcon: "icon-up-open",
				sortableIcon: "icon-sort",
			},
			tableFields: [
				{
					name: "type",
					title: "Action",
					formatter(value) {
						let string = value.replaceAll("_", " ");
						return string[0].toUpperCase() + string.slice(1);
					},
				},
				{
					name: "actBy",
					title: "Act by",
					formatter(value) {
						if (value != null) {
							return value.name;
						}
						return "";
					},
				},
				{
					name: "payload",
					title: "Details",
					formatter(value) {
						let obj = JSON.parse(value);
						delete obj["password"];
						let string = JSON.stringify(obj)
							.replaceAll("{", "")
							.replaceAll("}", "")
							.replaceAll('"', "")
							.replaceAll(":", ": ")
							.replaceAll(",", ", ");
						return string[0].toUpperCase() + string.slice(1);
					},
				},
				{
					name: "timestamp",
					title: "Time",
					sortField: "createdTimestamp",
					formatter(value) {
						return dayjs(value).format("HH:mm DD-MM-YYYY");
					},
				},
			],
			tableData: [],
			pagination: {
				total: 0,
				per_page: 25,
				current_page: 1,
				last_page: 0,
				from: 0,
				to: 0,
			},
		};
	},
	methods: {
		/**
		 * Show loading overlay.
		 */
		showLoadingOverlay() {
			this.$JsLoadingOverlay.show({ spinnerIcon: "ball-scale-multiple" });
		},

		/**
		 * Hide loading overlay.
		 */
		hideLoadingOverlay() {
			this.$JsLoadingOverlay.hide();
		},

		/**
		 * Function to be execute when you change the page from the vue table.
		 *
		 * 'reference' parameter will be used to update pagination info. It will let Vue know in which tab
		 * Vue should update.
		 *
		 * @param pageNumber
		 * @param reference
		 * @param productId
		 */
		changePage(pageNumber, reference) {
			this.showLoadingOverlay();

			// VueTable2 will return page number as 'next' or 'prev' when you click next page or previous page button.
			// Need to convert into the page number.
			if (pageNumber === "next") {
				pageNumber = this.pagination.current_page + 1;
			} else if (pageNumber === "prev") {
				pageNumber = this.pagination.current_page - 1;
			}

			// Get audit logs data.
			// The page number need to subtract 1 because page number in API start from 0.
			this.userTrailService
				.getUserTrails(pageNumber - 1, this.pagination.per_page)
				.then((response) => {
					this.tableData = response.data.userTrails;

					this.setPaginationData(response.data.count, pageNumber);

					// Update Vuetable-2 pagination data component.
					this.$refs["pagination" + reference].setPaginationData(
						this.pagination
					);
					this.$refs["paginationInfo" + reference].setPaginationData(
						this.pagination
					);

					this.hideLoadingOverlay();
				});
		},

		dataManager(sortOrder, pagination) {
			console.log(sortOrder, pagination);
		},

		// /**
		//  * Export alert logs data to CSV.
		//  */
		// downloadToCSV() {
		//     this.showLoadingOverlay();

		//     var headers = {
		//         id: 'ID',
		//         type: "Type",
		//         device: "Device",
		//         title: "Title",
		//         message: "Message",
		//         date: "Date",
		//     };

		//     this.alertService.getAlertData(this.pagination.current_page - 1, this.pagination.per_page, this.activeTab).then((response) => {
		//         let csvData = [];
		//         let csvFileName = 'Alert-Logs-' + dayjs().format('DD-MMM-YYYY_hh:mmA') + '.csv';

		//         response.data.alerts.forEach((alert) => {
		//             csvData.push({
		//                 id: alert.id,
		//                 type: alert.alertType,
		//                 device: alert.deviceId,
		//                 title: alert.title,
		//                 message: alert.message,
		//                 date: dayjs(alert.timestamp).format('YYYY-MM-DD HH:mm:ss'),
		//             })
		//         });

		//         // Add header.
		//         csvData.unshift(headers);

		//         // Convert Object to JSON
		//         let csvJson = JSON.stringify(csvData);

		//         let blob = new Blob([this.convertJsonToCSVText(csvJson)], {type: 'text/csv;charset=utf-8;'});

		//         if (navigator.msSaveBlob) { // IE 10+
		//             navigator.msSaveBlob(blob, csvFileName);
		//         } else {
		//             let link = document.createElement("a");

		//             if (link.download !== undefined) {
		//                 // Browsers that support HTML5 download attribute
		//                 var url = URL.createObjectURL(blob);
		//                 link.setAttribute("href", url);
		//                 link.setAttribute("download", csvFileName);
		//                 link.style.visibility = 'hidden';
		//                 document.body.appendChild(link);
		//                 link.click();
		//                 document.body.removeChild(link);
		//             }
		//         }
		//     })
		//     .finally(() => this.hideLoadingOverlay());
		// },

		// convertJsonToCSVText(jsonObject) {
		//     let array = typeof jsonObject != 'object' ? JSON.parse(jsonObject) : jsonObject;
		//     let str = '';

		//     for (let i = 0; i < array.length; i++) {
		//         let line = '';

		//         for (let index in array[i]) {
		//             if (line != '') line += ','

		//             line += array[i][index];
		//         }

		//         str += line + '\r\n';
		//     }

		//     return str;
		// },

		/**
		 * Set pagination data.
		 * API only return total of record available.
		 * Need to calculate pagination data manually.
		 *
		 * @param total
		 * @param pageNumber
		 */
		setPaginationData(total, pageNumber = 1) {
			this.pagination.current_page = pageNumber;
			this.pagination.total = total;
			this.pagination.last_page = Math.ceil(total / this.pagination.per_page);
			this.pagination.from = Math.ceil(
				this.pagination.current_page * this.pagination.per_page -
					(this.pagination.per_page - 1)
			);

			if (pageNumber === this.pagination.last_page) {
				this.pagination.to = total;
			} else {
				this.pagination.to = Math.ceil(
					this.pagination.current_page * this.pagination.per_page
				);
			}
		},
	},
	computed: {
		userTrailService: function () {
			return new UserTrailService();
		},
	},
	mounted() {
		this.showLoadingOverlay();

		// Get audit trails data.
		this.userTrailService
			.getUserTrails(this.pagination.current_page - 1, this.pagination.per_page)
			.then((response) => {
				this.tableData = response.data.userTrails;

				this.setPaginationData(response.data.count, 1);

				this.$refs.paginationLogs.setPaginationData(this.pagination);
				this.$refs.paginationInfoLogs.setPaginationData(this.pagination);
			})
			.finally(() => this.hideLoadingOverlay());
	},
};
</script>

<style lang="scss" scoped>
.per-page {
	width: 50%;
}

input[type="text"] {
	width: 65%;
}

.btn {
	margin: 0 0 0 1rem;
	padding: 0.8rem 1rem;

	&.btn-search {
		background: $green;
	}
}
</style>
